#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       event.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#
from util import make_id

class Event:
    signals = {}
    callbacks = {}

    def __init__(self):
        self.callbacks = {}
        self.signals = {}


    def emit(self, signal_name, *args, **kwargs):

        if not self.signals.has_key(signal_name):
            self.signals[signal_name] = []

        callback_ids = self.signals[signal_name]

        for callbackid in callback_ids:
            callback, sig_args = self.callbacks[callbackid]
            callback(self, *args + sig_args, **kwargs)


    def connect(self, signal_name, callback, *args):

        id = make_id(store=self.callbacks)
        if not self.signals.has_key(signal_name):
            self.signals[signal_name] = []

        self.signals[signal_name].append(id)
        cb = (callback, args)
        self.callbacks[id] = cb

    def disconnect(self, id):

        self.callbacks.pop(id)

